﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;

// Belly Bulger Plugin by Captain Varghoss
//
// Original plugin code by VRAdultFun
//
// 0.1 Fixed target atom selection to have scrollable popup - Captain Varghoss
// 0.2 Added additional morph increasing from 2 to 3 and adjusted calculations to compensate. - Captain Varghoss
// 1.0 Complete rewrite. All new custom morphs, increasing from 3 to 8 for more detailed bulging. - Captain Varghoss
//
// Shoutout to Juno for his tutorial and input with making the morphs, and thanks to VRAdultFun for the original plugin and idea.
//

namespace CaptainVarghoss {
	public class BellyBulger : MVRScript {
		protected JSONStorableBool isActive;
		protected JSONStorableStringChooser uiFocusTarget;
		protected JSONStorableFloat uiBulgeMult;
		protected JSONStorableFloat uiMinBulgeDistMult;
		protected JSONStorableFloat uiBulge1Mult;
		protected JSONStorableFloat uiBulge2Mult;
		protected JSONStorableFloat uiBulge3Mult;
		protected JSONStorableFloat uiBulge4Mult;
		protected JSONStorableFloat uiBulge5Mult;
		protected JSONStorableFloat uiBulge6Mult;
		protected JSONStorableFloat uiBulge7Mult;
		protected JSONStorableFloat uiBulge8Mult;

		protected JSONStorableFloat uiToyMulti;
		protected JSONStorableFloat uiCurrentDepth;
		protected UIDynamicTextField helpTextfield;
		protected JSONStorableString helpText;
		protected UIDynamicTextField helpTextfield2;
		protected JSONStorableString helpText2;
		protected JSONStorableString stateInfos;

		private static float toyFloat = 0.0f;
		private static float tempFloat = 0.0f;
//		private static float uiVagTrig = 0.0f;
//		private static float uiDeepVagTrig = 0.0f;
//		private static float uiDeeperVagTrig = 0.0f;
		
        private static FreeControllerV3 pelvisController;
		private Rigidbody _labiaTrigger;
		private Rigidbody _vaginaTrigger;
		private Rigidbody _deepVaginaTrigger; 
		private Rigidbody _deeperVaginaTrigger; 
        private static DAZMorph morphDeepBulgeBelly1;
        private static DAZMorph morphDeepBulgeBelly2;
		private static DAZMorph morphDeepBulgeBelly3;
		private static DAZMorph morphDeepBulgeBelly4;
		private static DAZMorph morphDeepBulgeBelly5;
		private static DAZMorph morphDeepBulgeBelly6;
		private static DAZMorph morphDeepBulgeBelly7;
		private static DAZMorph morphDeepBulgeBelly8;
		
        private static Atom person;
        private static Atom person2;
		private static Atom currentAtom;
		private static string currentAtomName = "None";
        private static FreeControllerV3 playerPelvisController;
        private static FreeControllerV3 playerTipController;
        private static FreeControllerV3 playerTipBaseController;
		private static bool isObject = false;

		public override void Init() {
			try {
				// Active Toggle
				isActive = new JSONStorableBool ("isActive", true);
				RegisterBool (isActive);
				var toggle = CreateToggle(isActive);
				toggle.label = "Active";
				
				JSONStorableAction ToggleActive = new JSONStorableAction("Toggle Belly Bulger", () =>
                {
                    isActive.val = !isActive.val;
                });
                RegisterAction(ToggleActive);
				List<string> targetChoices = new List<string>();
				foreach (string atomUID in SuperController.singleton.GetAtomUIDs())
				{
					currentAtom = SuperController.singleton.GetAtomByUid(atomUID);
					if (currentAtom != containingAtom && atomUID != null)
					{
						targetChoices.Add(atomUID);
					}
				}
				uiFocusTarget = new JSONStorableStringChooser("Sex Giver", targetChoices, "None", "Choose Person");
				RegisterStringChooser(uiFocusTarget);
				UIDynamicPopup udp = CreateScrollablePopup(uiFocusTarget, true);
				
				uiBulgeMult = new JSONStorableFloat("Belly Bulge Multiplier", 0.70f, 0.0f, 3.0f, true, true);
				RegisterFloat(uiBulgeMult);
				CreateSlider(uiBulgeMult, false);
				
				uiMinBulgeDistMult = new JSONStorableFloat("Min Bulge Dist Multiplier", 1.0f, 0.0f, 5.0f, true, true);
				RegisterFloat(uiMinBulgeDistMult);
				CreateSlider(uiMinBulgeDistMult, false);
				
				uiToyMulti = new JSONStorableFloat("Toy Distance Multiplier", 5.0f, 0.0f, 5.0f, true, true);
				RegisterFloat(uiToyMulti);
//				CreateSlider(uiToyMulti, false);
				
				uiCurrentDepth = new JSONStorableFloat("Current Depth", 0.0f, -1.0f, 1.0f, true, true);
				RegisterFloat(uiCurrentDepth);
//				CreateSlider(uiCurrentDepth, false);
				
				var btn = CreateButton("Reset Morphs", false);
                btn.button.onClick.AddListener(() => { ResetMorphs(); });
				
				helpText = new JSONStorableString("Helptext", "\n<b>Belly Bulger</b>\n\nChoose person: Select the atom that is performing the insertion, person and toy atoms work.\n\nSet Belly Bulge Multiplier to change how much of the morphs are used\n\nSet Min Bulge Dist Multiplier to fake actual depth, this helps with making the insertion appear much deeper than possible due to collisions.\n\nIf morphs get stuck for some reason, use the Reset Morphs button or toggle the active checkbox.");
				UIDynamic helpTextfield = CreateTextField(helpText, true);
				helpTextfield.height = 700f;
//				stateInfos = new JSONStorableString("Stateinfos", "");
//				UIDynamic stateinfosTextfield = CreateTextField(stateInfos, false);
//				stateinfosTextfield.height = 180.0f;

				// Per morph multiplier reducers
				helpText2 = new JSONStorableString("Helptext2", "\n<b>Bulge Morph Adjustments</b>\n\nUse these morphs to reduce Bulge Multiplier on individual morphs.\nThese can help on male/futa models that morph oddly. Also helps with the first morph being \"too much\".");
				UIDynamic helpTextfield2 = CreateTextField(helpText2, false);
				helpTextfield2.height = 300f;
				
				uiBulge1Mult = new JSONStorableFloat("Bulge 1 Amount Mult", 1.0f, 0.0f, 1.0f, true, true);
				RegisterFloat(uiBulge1Mult);
				CreateSlider(uiBulge1Mult, false);

				uiBulge2Mult = new JSONStorableFloat("Bulge 2 Amount Mult", 1.0f, 0.0f, 1.0f, true, true);
				RegisterFloat(uiBulge2Mult);
				CreateSlider(uiBulge2Mult, false);

				uiBulge3Mult = new JSONStorableFloat("Bulge 3 Amount Mult", 1.0f, 0.0f, 1.0f, true, true);
				RegisterFloat(uiBulge3Mult);
				CreateSlider(uiBulge3Mult, false);

				uiBulge4Mult = new JSONStorableFloat("Bulge 4 Amount Mult", 1.0f, 0.0f, 1.0f, true, true);
				RegisterFloat(uiBulge4Mult);
				CreateSlider(uiBulge4Mult, false);

				uiBulge5Mult = new JSONStorableFloat("Bulge 5 Amount Mult", 1.0f, 0.0f, 1.0f, true, true);
				RegisterFloat(uiBulge5Mult);
				CreateSlider(uiBulge5Mult, false);

				uiBulge6Mult = new JSONStorableFloat("Bulge 6 Amount Mult", 1.0f, 0.0f, 1.0f, true, true);
				RegisterFloat(uiBulge6Mult);
				CreateSlider(uiBulge6Mult, false);

				uiBulge7Mult = new JSONStorableFloat("Bulge 7 Amount Mult", 1.0f, 0.0f, 1.0f, true, true);
				RegisterFloat(uiBulge7Mult);
				CreateSlider(uiBulge7Mult, false);

				uiBulge8Mult = new JSONStorableFloat("Bulge 8 Amount Mult", 1.0f, 0.0f, 1.0f, true, true);
				RegisterFloat(uiBulge8Mult);
				CreateSlider(uiBulge8Mult, false);

				_labiaTrigger = containingAtom.rigidbodies.First(rb => rb.name == "LabiaTrigger");
				_vaginaTrigger = containingAtom.rigidbodies.First(rb => rb.name == "VaginaTrigger");
				_deepVaginaTrigger = containingAtom.rigidbodies.First(rb => rb.name == "DeepVaginaTrigger");
				_deeperVaginaTrigger = containingAtom.rigidbodies.First(rb => rb.name == "DeeperVaginaTrigger");

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		void Start() {
			try {
				person = containingAtom;
				if (person != null)
				{
					pelvisController = person.GetStorableByID("hipControl") as FreeControllerV3;
					
					ResetMorphs();
					
					if (uiFocusTarget.val != "none")
					{
						person2 = SuperController.singleton.GetAtomByUid(uiFocusTarget.val);
						if (person2 != null)
						{
							playerPelvisController = person2.GetStorableByID("pelvisControl") as FreeControllerV3;
						}
					}
				}
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}
		
		private void ResetMorphs() {
			JSONStorable js = person.GetStorableByID("geometry");
			DAZCharacterSelector dcs = js as DAZCharacterSelector;
			GenerateDAZMorphsControlUI morphUI = dcs.morphsControlUI;
			
			if (morphUI != null) {
				morphDeepBulgeBelly1 = morphUI.GetMorphByDisplayName("Belly Bulger 1");
				morphDeepBulgeBelly1.Reset();
				morphDeepBulgeBelly2 = morphUI.GetMorphByDisplayName("Belly Bulger 2");
				morphDeepBulgeBelly2.Reset();
				morphDeepBulgeBelly3 = morphUI.GetMorphByDisplayName("Belly Bulger 3");
				morphDeepBulgeBelly3.Reset();
				morphDeepBulgeBelly4 = morphUI.GetMorphByDisplayName("Belly Bulger 4");
				morphDeepBulgeBelly4.Reset();
				morphDeepBulgeBelly5 = morphUI.GetMorphByDisplayName("Belly Bulger 5");
				morphDeepBulgeBelly5.Reset();
				morphDeepBulgeBelly6 = morphUI.GetMorphByDisplayName("Belly Bulger 6");
				morphDeepBulgeBelly6.Reset();
				morphDeepBulgeBelly7 = morphUI.GetMorphByDisplayName("Belly Bulger 7");
				morphDeepBulgeBelly7.Reset();
				morphDeepBulgeBelly8 = morphUI.GetMorphByDisplayName("Belly Bulger 8");
				morphDeepBulgeBelly8.Reset();
			}
		}
		
		void FixedUpdate() {
			if (isActive.val == true) {
				try {
					currentAtomName = uiFocusTarget.val;
					if ((person2 == null || playerTipController == null) && currentAtomName != "None")
					{
						person2 = SuperController.singleton.GetAtomByUid(uiFocusTarget.val);
						if (person2 == null)
						{
							uiFocusTarget.val = "None";
							currentAtomName = "None";
						}
						else
						{
							if (person2.type == "Person")
							{
								isObject = false;
								toyFloat = 0.0f;
								playerTipController = person2.GetStorableByID("penisTipControl") as FreeControllerV3;
							}
							else
							{
								isObject = true;
								toyFloat = uiToyMulti.val;
								playerTipController = person2.GetStorableByID("control") as FreeControllerV3;
							}
						}
					}
					if (morphDeepBulgeBelly1 != null && morphDeepBulgeBelly2 != null && morphDeepBulgeBelly3 != null && morphDeepBulgeBelly4 != null && morphDeepBulgeBelly5 != null && morphDeepBulgeBelly6 != null && morphDeepBulgeBelly7 != null && morphDeepBulgeBelly8 != null && person2 != null && playerTipController != null)
					{
						tempFloat = Vector3.Distance(pelvisController.followWhenOff.position, playerTipController.followWhenOff.position);
						// Testing different measurements
//						uiVagTrig = Vector3.Distance(_vaginaTrigger.position, playerTipController.followWhenOff.position);
//						uiDeepVagTrig = Vector3.Distance(_deepVaginaTrigger.position, playerTipController.followWhenOff.position);
//						uiDeeperVagTrig = Vector3.Distance(_deeperVaginaTrigger.position, playerTipController.followWhenOff.position);
//						tempFloat = uiVagTrig;

						// Morph 1
						if ( tempFloat < 0.15f * uiMinBulgeDistMult.val)
						{	
							morphDeepBulgeBelly1.morphValue = Mathf.Clamp((1.0f - (tempFloat*(6.666f / uiMinBulgeDistMult.val))) * (uiBulgeMult.val * uiBulge1Mult.val),0.0f,1.0f);
						}
						else
						{
							morphDeepBulgeBelly1.Reset();
						}
						// Morph 2
						if ( tempFloat < 0.13f * uiMinBulgeDistMult.val)
						{
							morphDeepBulgeBelly2.morphValue = Mathf.Clamp((1.0f - (tempFloat*(12f / uiMinBulgeDistMult.val))) * (uiBulgeMult.val * uiBulge2Mult.val),0.0f,1.0f);
						}
						else
						{
							morphDeepBulgeBelly2.Reset();
						}
						// Morph 3
						if ( tempFloat < 0.11f * uiMinBulgeDistMult.val)
						{
							morphDeepBulgeBelly3.morphValue = Mathf.Clamp((1.0f - (tempFloat*(12f / uiMinBulgeDistMult.val))) * (uiBulgeMult.val * uiBulge3Mult.val),0.0f,1.0f);
						}
						else
						{
							morphDeepBulgeBelly3.Reset();
						}
						// Morph 4
						if ( tempFloat < 0.09f * uiMinBulgeDistMult.val)
						{
							morphDeepBulgeBelly4.morphValue = Mathf.Clamp((1.0f - (tempFloat*(18f / uiMinBulgeDistMult.val))) * (uiBulgeMult.val * uiBulge4Mult.val),0.0f,1.0f);
						}
						else
						{
							morphDeepBulgeBelly4.Reset();
						}
						// Morph 5
						if ( tempFloat < 0.07f * uiMinBulgeDistMult.val)
						{
							morphDeepBulgeBelly5.morphValue = Mathf.Clamp((1.0f - (tempFloat*(24f / uiMinBulgeDistMult.val))) * (uiBulgeMult.val * uiBulge5Mult.val),0.0f,1.0f);
						}
						else
						{
							morphDeepBulgeBelly5.Reset();
						}
						// Morph 6
						if ( tempFloat < 0.05f * uiMinBulgeDistMult.val)
						{
							morphDeepBulgeBelly6.morphValue = Mathf.Clamp((1.0f - (tempFloat*(30f / uiMinBulgeDistMult.val))) * (uiBulgeMult.val * uiBulge6Mult.val),0.0f,1.0f);
						}
						else
						{
							morphDeepBulgeBelly6.Reset();
						}
						// Morph 7
						if ( tempFloat < 0.03f * uiMinBulgeDistMult.val)
						{
							morphDeepBulgeBelly7.morphValue = Mathf.Clamp((1.0f - (tempFloat*(36f / uiMinBulgeDistMult.val))) * (uiBulgeMult.val * uiBulge7Mult.val),0.0f,1.0f);
						}
						else
						{
							morphDeepBulgeBelly7.Reset();
						}
						// Morph 8
						if ( tempFloat < 0.025f * uiMinBulgeDistMult.val)
						{
							morphDeepBulgeBelly8.morphValue = Mathf.Clamp((1.0f - (tempFloat*(42f / uiMinBulgeDistMult.val))) * (uiBulgeMult.val * uiBulge8Mult.val),0.0f,1.0f);
						}
						else
						{
							morphDeepBulgeBelly8.Reset();
						}


					}
					
					uiCurrentDepth.val = tempFloat;
//					string stateVal = "<color=#000><size=30><b>State:</b></size></color>\n<color=#333><size=25>";
//						stateVal += "Pelvis Control: <b>" + tempFloat + "</b>\n";
//						stateVal += "Vagina Trigger: <b>" + uiVagTrig + "</b>\n";
//						stateVal += "Deep Vagina Trigger: <b>" + uiDeepVagTrig + "</b>\n";
//						stateVal += "Deeper Vagina Trigger: <b>" + uiDeeperVagTrig + "</b>\n";
//						stateVal += "Morph 1 Value: <b>" + morphDeepBulgeBelly1.LoadDeltas + "</b>\n";
//						stateVal += "</size></color>";
//					stateInfos.val = stateVal;
				
				}
				catch (Exception e) {
					SuperController.LogError("Exception caught: " + e);
				}
			} else { ResetMorphs(); }
		}

		void OnDestroy() {
		}

	}
}